<template>
  <b-overlay :show="loading" rounded="sm">
    <b-container>
      <b-row>
        <b-form-group
          id="region-filter-group"
          description="Filtra los gráficos por región"
          label="Filtro de región"
          label-for="region-filter"
        >
          <b-form-select
            id="region-filter"
            v-model="selected_region"
            :options="regions"
            @change="refreshData"
          >
          </b-form-select>
        </b-form-group>
      </b-row>
      <b-row>
        <b-col
          cols="6"
          class="pt-5 h-50"
          v-for="(sumcollection, index) in sumdatacollections"
          :key="index"
        >
          <b-card class="shadow" :header="sumcollection.title">
            <BarChart :chart-data="sumcollection.data" />
          </b-card>
        </b-col>
      </b-row>
      <b-row>
        <b-col
          cols="6"
          class="pt-5"
          v-for="(datacollection, index) in datacollections"
          :key="index"
        >
          <b-card class="shadow" :header="datacollection.title">
            <LineChart :chart-data="datacollection.data" />
          </b-card>
        </b-col>
      </b-row>
    </b-container>
  </b-overlay>
</template>

<script>
import LineChart from "@/components/LineChart.vue";
import BarChart from "@/components/BarChart.vue";

export default {
  components: {
    LineChart,
    BarChart
  },
  data() {
    return {
      loading: false,
      regions: [],
      sumdatacollections: [],
      datacollections: [],
      selected_region: null
    };
  },
  mounted() {
    this.loadRegions();
    this.refreshData();
  },
  methods: {
    refreshData() {
      this.loading = true;
      let promises = [];
      promises.push(this.loadSumData());
      promises.push(this.loadByDayData());
      Promise.all(promises).then(
        () => {
          this.loading = false;
        },
        () => {
          // TODO: show error
          this.loading = true;
        }
      );
    },
    loadRegions() {
      this.regions.push({
        value: null,
        text: "----"
      });
      this.$fetchget("/logistica/basic/region/")
        .then(res => res.json())
        .then(data => {
          data.results.forEach(element => {
            this.regions.push({
              value: element.pk,
              text: element.name
            });
          });
        });
    },
    loadSumData() {
      this.sumdatacollections = [];
      let query_params = undefined;
      if (this.selected_region) {
        query_params = { region: this.selected_region };
      }
      const uri = this.$parseurl(
        "/logistica/stats/resource/bydaysumresources/",
        undefined,
        query_params
      );

      return this.$fetchget(uri).then(res => {
        res.json().then(data => {
          if (res.ok) {
            let labels = [];
            let values = [];
            data.results.forEach(resource => {
              labels.push(resource.name + " (construidos)");
              values.push(resource.stats_sum.build_static_value);
              labels.push(resource.name + " (entregados)");
              values.push(resource.stats_sum.deliver_static_value);
            });

            this.sumdatacollections.push({
              title: "Totales",
              data: {
                labels: labels,
                datasets: [
                  {
                    label: "Totales",
                    data: values
                  }
                ]
              }
            });
          } else {
            // error
          }
        });
      });
    },
    loadByDayData() {
      this.datacollections = [];
      let query_params = { from_date: "2020-01-01" };
      if (this.selected_region) {
        query_params["region"] = this.selected_region;
      }
      const uri = this.$parseurl(
        "/logistica/stats/resource/bydayresources/",
        undefined,
        query_params
      );

      return this.$fetchget(uri).then(res => {
        res.json().then(data => {
          if (res.ok) {
            let labels = [];
            let datasets = [];
            data.results.forEach(resource => {
              resource.stats_by_region.forEach(region => {
                labels = region.stats.build_static_labels;
                datasets = [
                  {
                    label: "Fabricado",
                    data: region.stats.build_static_values
                  },
                  {
                    label: "Entregado",
                    data: region.stats.deliver_static_values
                  }
                ];
                this.datacollections.push({
                  title: region.region.name + " " + resource.name,
                  data: {
                    labels: labels,
                    datasets: datasets
                  }
                });
              });
            });
          } else {
            // error
          }
        });
      });
    }
  }
};
</script>

<style></style>
